#include "common.h"

#include "Anima.h"

CAnima::CAnima()
{
	bool liveFlag = false;

	anima.setSize(15.0, 55.0, 15.0);
	animaModel.setShape(&anima);
	animaModel.setMaterial(Red);
	animaModel.setSmoothMode(true);

	animaOBB.setBlockSize(15.0, 45.0, 15.0);
	animaOBB.setModel(&animaModel);


	throwBlock.setSize( 8.0, 8.0, 8.0);
	throwBlockModel.setShape(&throwBlock);
	throwBlockModel.setMaterial(Green);
	throwBlockModel.setSmoothMode(true);

	throwBlockOBB.setBlockSize(8.0, 8.0, 8.0);
	throwBlockOBB.setModel(&throwBlockModel);

	blockFlag = false;
	throwFlag = false;
	throwLV = 1;
	countToThrow = 60;

	throwBlockDistance = 0;

	attackDamage = 2;	//Aj}X[̃_[Wl

	animaSpd = (0, 0, 0);
	animaThrowBlockSpd = (0, 0, 0);

	return;
}

CAnima::~CAnima()
{
}

//Aj}̃Gg[ƃ[u
void CAnima::entryAnima(fk_Scene *argScene)
{
	if(liveFlag == true)
	{
		argScene->entryModel(&animaModel);
	}
	else
	{
		argScene->removeModel(&animaModel);
	}

	return;
}

//OBB擾
fkut_OBB CAnima::getOBB()
{
	return animaOBB;
}

//Aj}X[pubNij̃Gg[ƃ[u
void CAnima::entryAnimaThrowBlock(fk_Scene *argScene)
{
	if(blockFlag == true)
	{
		argScene->entryModel(&throwBlockModel);
	}
	else
	{
		argScene->removeModel(&throwBlockModel);
	}
	
	return;
}

//Aj}̏
void CAnima::summonAnima(fk_Vector pos, int blockCount)
{
	if(liveFlag == false)
	{
		liveFlag = true;
		animaModel.glMoveTo(pos);
		animaModel.loTranslate( -10.0, -10.0, 0.0);

		blockFlag = true;
		throwBlockModel.glMoveTo(animaModel.getPosition());
		throwBlockModel.loTranslate( 15.0, 30.0, 0.0);
		
		nowCount = 0;

		switch(blockCount)
		{
		case 1:
			throwLV = 1;
			attackDamage = 2;
			countToThrow = 60;
			break;

		case 2:
			throwLV = 2;
			attackDamage = 5;
			countToThrow = 90;
			break;

		case 3:
			throwLV = 3;
			attackDamage = 9;
			countToThrow = 120;
			break;

		case 4:
			throwLV = 4;
			attackDamage = 14;
			countToThrow = 150;
			break;

		case 5:
			throwLV = 5;
			attackDamage = 20;
			countToThrow = 180;
			break;

		case 6:
			throwLV = 6;
			attackDamage = 30;
			countToThrow = 210;
			break;

		default:
			break;

		}
	}
	return;
}

//Aj}݂ꍇAAj}X[܂ł̎Ԃ̏
void CAnima::decCountToThrow()
{
	if(liveFlag == true)
	{
		nowCount ++;
	}

	return;
}

//Aj}X[̔
void CAnima::setAnimaThrow(fk_Vector pos)
{
	if(liveFlag == true )
	{
		if(countToThrow <= nowCount)
		{
			nowCount = 0;
			throwBlockModel.glFocus(pos);		//G̕
			throwFlag = true;
		}
	}

	return;
}

//Aj}X[̌o߁iubN̈ړj
void CAnima::procAnimaThrow()
{
	if(throwFlag == true)
	{
		throwBlockModel.loTranslate(0.0, 0.0, -3.0);
		throwBlockDistance += 3;					//ubNׂ̏̈ɃubN̈ړZ
	}

	return;
}

//_[Wl̎擾
double CAnima::getAttackDamage(double comboBonus)
{
	double returnDamage = attackDamage*comboBonus;
	attackDamage = 2;
	return returnDamage;
}

//Aj}̑݃tO擾
bool CAnima::getLiveFlag()
{
	return liveFlag;
}

//ubN̉x̃AhX擾
fk_Vector * CAnima::getPSpd()
{
	return &animaSpd;
}

//ubN̉x̃AhX擾
fk_Vector * CAnima::getAnimaThrowBlockSpdAddress()
{
	return &animaThrowBlockSpd;
}

//Փ˔菈iՓˎ̓ubN܂
bool CAnima::checkCollision(fkut_OBB &hitOBB, fk_Vector *spd)
{
	bool judge = false;

	static fk_Vector refV;

	throwBlockModel.setMaterial(Gray1);	

	// Փ˔̊Jn
	if(blockFlag == true)
	{
		if(throwBlockOBB.checkVSMovingOBB(hitOBB, (*spd), refV )) 
		{
			throwBlockModel.setMaterial(Red); 
			judge = true;

			//uOėꂷubN̏tOvƓl̏s
			blockFlag = false;
			throwFlag = false;
			liveFlag = false;
			throwBlockDistance = 0;
		}
	}
		
	return judge;
}

//ubN̏tO
void CAnima::setAnimaThrowBlock(bool isHit)
{
	for(int i = 0; i < 6; i++ )
	{
		if(isHit == true )
		{
			liveFlag = false;
			throwFlag = false;										//蔻
			blockFlag = false;									//݂Ȃɐݒ
			throwBlockDistance = 0;										//ړZbg
		}

		if(throwBlockDistance > 400)	//ubN̈ړ400ȏ̎
		{
			liveFlag = false;
			throwFlag = false;										//蔻
			blockFlag = false;									//݂Ȃɐݒ
			throwBlockDistance = 0;										//ړZbg
		}
	}
	return;
}