#include "common.h"

#include "Camera.h"

CCamera::CCamera(fk_Vector pos)
{
	camera.glMoveTo(0.0, 100.0, -300.0);
	camera.glFocus(0.0, 0.0, 0.0);
	camera.glUpvec(0.0, 1.0, 0.0);

	moveModel.glMoveTo( 0.0, 100.0, -300.0);
	moveModel.glFocus(0.0, 0.0, 0.0);
	moveModel.glUpvec(0.0, 1.0, 0.0);

	nowPos = fk_Vector( 0.0, 100.0, -300.0);
	toPos = fk_Vector( 0.0, 100.0, -300.0);

	nowFocus = (pos);
	toFocus = (pos);

	debugNum = 1;

	return;
};

CCamera::~CCamera(void)
{
};

void CCamera::entryScene(fk_Scene *argScene)
{
	argScene->entryModel(&camera);
	
	return;
}

//Jf̃AhX擾
fk_Model * CCamera::getCameraModelAddress()
{
	return &camera;
}

//J̃f擾
fk_Model CCamera::getCameraModel()
{
	return camera;
}

//J̌擾
fk_Vector CCamera::getCameraVec()
{
	return camera.getVec();
}

//J̈ʒu擾
fk_Vector CCamera::getCameraPos()
{
	return camera.getPosition();
}

//J̈ړivC[̔wƂ@X
void CCamera::moveCameraPos(fk_Vector playerPos, fk_Vector playerVec, fk_Vector enemyPos)
{
	camera.glMoveTo(playerPos);
	camera.glVec(playerVec);
	if(debugNum != 0 )
	{
		//camera.loTranslate(0.0, 90.0, -300.0);
		camera.loTranslate(0.0, 60.0, -300.0);
	}
	else
	{
		camera.loTranslate(-250.0, 90.0, -200.0);
	}

	if(enemyPos.y > playerPos.y)
	{
		camera.loTranslate(0.0, ((enemyPos.y - playerPos.y)/4), -((enemyPos.y - playerPos.y)*2.0));
	}
	if(playerPos.y > 80.0)
	{
		camera.loTranslate(0.0, 0.0, -camera.getPosition().y+80.0);
	}
	toPos = camera.getPosition();

	if( nowPos != toPos )
	{
		nowPos += ( toPos - nowPos )/10;
	}
	camera.glMoveTo(nowPos);
	camera.glVec(playerVec);
	return;
}

//J̏œ_ړiX
void CCamera::moveCameraFocus(fk_Vector enemyPos)
{
	toFocus = enemyPos;
	
	if( toFocus != nowFocus )
	{
		nowFocus += (toFocus - nowFocus)/10;
	}

	nowFocus.y -= 5;

	camera.glFocus(nowFocus);
	camera.glUpvec(0.0, 1.0, 0.0);
	return;
}

//J̏ݒ̏
void CCamera::initCamera(fk_Vector pos)
{
	camera.glMoveTo(0.0, 100.0, -300.0);
	camera.glFocus(0.0, 0.0, 0.0);
	camera.glUpvec(0.0, 1.0, 0.0);

	moveModel.glMoveTo( 0.0, 100.0, -300.0);
	moveModel.glFocus(0.0, 0.0, 0.0);
	moveModel.glUpvec(0.0, 1.0, 0.0);

	nowPos = fk_Vector(0.0, 100.0, -300.0);
	toPos = fk_Vector(0.0, 100.0, -300.0);

	nowFocus = (pos);
	toFocus = (pos);

	return;
}

//_؂ւfobOp
void CCamera::debugChangeMode()
{
	if(debugNum != 0 )
	{
		//蔻
		debugNum = 0;
	}
	else
	{
		//蔻o
		debugNum = 1;
	}
	return;
}

//fobO
void CCamera::debug()
{
	printf( "%lf,%lf,%lf\n", camera.getPosition().x, camera.getPosition().y, camera.getPosition().z);
	return;
}