#include "common.h"

#include "Field.h"

CField::CField(void)
{
	fk_Material::initDefault();

	for(int i = 0; i < blockNum; i++) {
		obb[i].setBlockSize(45.0, 10.0, 45.0);
		obb[i].setModel(&blockModel[i]);
		block[i].setSize(45.0, 10.0, 45.0);
		blockModel[i].setMaterial(Yellow);
	}
	
	for(int i = 0; i < blockNum; i++ )
	{
		judgeCatch[i] = 1;
	}


	blockModel[0].glMoveTo(0.0, -5.0, 0.0);

	for(int i=1 ; i < 9; i++)
	{
		blockModel[i].glMoveTo(0.0, -5.0, -45.0*i);
	}
	for(int i=9 ; i < 18; i++)
	{
		blockModel[i].glMoveTo(45.0, -5.0, -45.0*(i-9));
	}
	for(int i=18 ; i < 27; i++)
	{
		blockModel[i].glMoveTo(90.0, -5.0, -45.0*(i-18));
	}
	for(int i=27 ; i < 36; i++)
	{
		blockModel[i].glMoveTo(135.0, -5.0, -45.0*(i-27));
	}
	for(int i=36 ; i < 45; i++)
	{
		blockModel[i].glMoveTo(180.0, -5.0, -45.0*(i-36));
	}
	for(int i=45 ; i < 54; i++)
	{
		blockModel[i].glMoveTo(-45.0, -5.0, -45.0*(i-45));
	}
	for(int i=54 ; i < 63; i++)
	{
		blockModel[i].glMoveTo(-90.0, -5.0, -45.0*(i-54));
	}
	for(int i=63 ; i < 72; i++)
	{
		blockModel[i].glMoveTo(-135.0, -5.0, -45.0*(i-63));
	}
	for(int i=72 ; i < 81; i++)
	{
		blockModel[i].glMoveTo(-180.0, -5.0, -45.0*(i-72));
	}
	for(int i = 0; i < blockNum; i++) {
		blockModel[i].setShape(&block[i]);
		blockModel[i].setSmoothMode(true);
	}

	for(int i = 0; i < blockNum; i++) 
	{
		if(judgeCatch[i] != 0)
		{
			if(!blockObj[i].loadObjectData("field/floorcube.mqo")) fl_alert("[floorcube.mqo] Read Error.");
			if(!blockObj[i].loadJointData("field/floorcube.fkc")) fl_alert("[floorcube.fkc] Read Error.");
		}
	}

	if(!standBlockObj.loadObjectData("field/floorcube_red.mqo")) fl_alert("[floorcube_red.mqo] Read Error.");
	if(!standBlockObj.loadJointData("field/floorcube.fkc")) fl_alert("[floorcube.fkc] Read Error.");

	spd = fk_Vector(0.0, 0.0, 0.0);

	if( !bgTex[0].readPNG( "image/bg_under.png" ) )	fl_alert( "error read[bg_under.png]" );
	bgTex[0].setTextureSize( 4096.0 , 4096.0 );
	bgTex[0].setTexRendMode( FK_TEX_REND_NORMAL );
	bgTex[0].setTextureMode( FK_TEX_REPLACE );
	bgModel[0].setShape( &bgTex[0] );
	bgModel[0].glMoveTo( 0.0 , -1010.0 , 0.0 );
	bgModel[0].glFocus( 0.0 , -1025.0 , 0.0 );
	if( !bgTex[5].readPNG( "image/bg_over.png" ) )	fl_alert( "error read[bg_over.png]" );
	bgTex[5].setTextureSize( 4096.0 , 4096.0 );
	bgTex[5].setTexRendMode( FK_TEX_REND_NORMAL );
	bgTex[5].setTextureMode( FK_TEX_REPLACE );
	bgModel[5].setShape( &bgTex[5] );
	bgModel[5].glMoveTo( 0.0 , 3060.0 , 0.0 );
	bgModel[5].glFocus( 0.0 , 3080.0 , 0.0 );
	for(int i=1 ; i<5 ; i++)
	{
		if( !bgTex[i].readPNG( "image/bg_side.png" ) )
		{
			fl_alert( "error read[bg_side.png]" );
		}
		else
		{
			bgTex[i].setTextureSize( 4096.0 , 4096.0 );
			bgTex[i].setTexRendMode( FK_TEX_REND_SMOOTH );
			bgTex[i].setTextureMode( FK_TEX_REPLACE );
			bgModel[i].setShape( &bgTex[i] );
			if( i == 4 )
			{
				bgModel[1].glMoveTo( 2048.0 , 1024.0 , 0.0 );
				bgModel[2].glMoveTo( 0.0 , 1024.0 , 2048.0 );
				bgModel[3].glMoveTo( -2048.0 , 1024.0 , 0.0 );
				bgModel[4].glMoveTo( 0.0 , 1024.0 , -2048.0 );
				bgModel[1].glFocus( 2050.0 , 1024.0 , 0.0 );
				bgModel[2].glFocus( 0.0 , 1024.0 , 2050.0 );
				bgModel[3].glFocus( -2050.0 , 1024.0 , 0.0 );
				bgModel[4].glFocus( 0.0 , 1024.0 , -2050.0 );
			}
		}
	}
	
	return;
}

CField::~CField(void)
{
}

void CField::entryScene(fk_Scene *argScene)
{
	for(int i = 0; i < blockNum; i++) {
		argScene->entryModel(&blockModel[i]);
	}

	for(int i = 0; i < 6; i++ )
	{
		argScene->entryModel(&bgModel[i]);
	}

	for(int i = 0; i < blockNum; i++) {
		blockObj[i].entryScene(argScene);
	}

	standBlockObj.entryScene(argScene);

	return;
}

//*spd擾
fk_Vector * CField::getPSpd()
{
	return &spd;
}

//obb擾
fkut_OBB CField::getObb(int num)
{
	return obb[num];
}

//ubN擾
int	CField::getBlockNum()
{
	return blockNum;
}

bool CField::checkCollisionToPlayer(fkut_OBB &playerOBB, fk_Vector *spd)
{
	static fk_Vector back, refV, spdXZ, spdY;
	bool standFlag = false;

	//x
	spdXZ.set(spd->x, 0.0, spd->z);
	spdY.set(0.0, spd->y, 0.0);

	//ubNɐGĂȂ
	judgeStand = -9999;

	
	// Փ˔̊Jn
	for(int i = 0; i < blockNum; i++) {
		blockModel[i].setMaterial(Green);
	}


	do {
		back.init();
		for(int i = 0; i < blockNum; i++) {
			if(obb[i].checkVSMovingOBB(playerOBB, spdXZ+back, refV)) 
			{
				if( judgeCatch[i] > 0 )
				{
					back += -refV;
					blockModel[i].setMaterial(Red); 
					judgeStand = i;
				}
			}
		}
		if(abs(back.y) > 0.0)
		{
			standFlag = true;
		}
		spdXZ += back;
	} while(!back.isZero());
	// Փ˂̔͂𑬓xɉXZI
	
	do {
		back.init();
		for(int i = 0; i < blockNum; i++) {
			if(obb[i].checkVSMovingOBB(playerOBB, spdY+back, refV)) 
			{
				if( judgeCatch[i] > 0 )
				{
					back += -refV;
					blockModel[i].setMaterial(Red); 
					judgeStand = i;
				}
			}
		}
		if(abs(back.y) > 0.0)
		{
			standFlag = true;
		}
		spdY += back;
	} while(!back.isZero());

	*spd = spdXZ + spdY;

	return standFlag;
}


//͂߂鑫ꂩǂ
int CField::getJudgeCatch(int blockNum)
{
	if( blockNum < 0 )
	{
		return judgeCatch[judgeStand];
	}
	else
	{
		return judgeCatch[blockNum];
	}
}

//񂾃ubÑtO
void CField::setBlockCatch(fk_Scene *argScene)
{
	if( judgeCatch[judgeStand] != 0 )	{
		judgeCatch[judgeStand] = 0;
		standBlockObj.removeScene(argScene);
	}
	return;
}

//ubÑIuWFNgf[^̈ʒu
void CField::drawBlockObj()
{
	for(int i = 0; i < blockNum; i++ )
	{
		if( judgeCatch[i] != 0 )
		{
			blockObj[i].getBaseModel()->glMoveTo(blockModel[i].getPosition().x, blockModel[i].getPosition().y-38.0, blockModel[i].getPosition().z);
		}
	}

	if(judgeStand != -9999 )
	{
		standBlockObj.getBaseModel()->glMoveTo(blockModel[judgeStand].getPosition().x, blockModel[judgeStand].getPosition().y-15.0, blockModel[judgeStand].getPosition().z);
	}
	return;
}

//ubÑIuWFNg̃[uƃGg[
void CField::updateBlockObj(fk_Scene *argScene)
{
	standBlockObj.removeScene(argScene);
	if(judgeStand > -1 )
	{
		blockObj[judgeStand].removeScene(argScene);
		if(judgeCatch[judgeStand] != 0 )
		{
			standBlockObj.entryScene(argScene);
		}
	}
	
	for(int i = 0; i < blockNum; i++) 
	{
		if(judgeCatch[i] != 0 )
		{
			if( i != judgeStand)
			{
				blockObj[i].entryScene(argScene);
			}
		}
	}

	return;
}


//ubN`攻菈
void CField::drawBlock()
{
	for(int i = 0; i < blockNum; i++ )
	{
		if( judgeCatch[i] > 0 )
		{
			blockModel[i].setDrawMode(FK_POLYMODE);
		}
		else
		{
			blockModel[i].setDrawMode(FK_NONEMODE);	
		}
	}
	return;
}

//tB[h̏ݒ菉
void CField::initField()
{
	for(int i = 0; i < blockNum; i++ )
	{
		judgeCatch[i] = 1;
	}
	return;
}

void CField::debug()
{
	//printf( "[1]size:%d\n", block[1].getBlockSize() );
	return;
}
